#IfWinActive, ahk_class Skyrim
#InstallKeybdHook
#SingleInstance force
#MaxThreads 1
#MaxThreadsPerHotkey 1
#MaxThreadsBuffer Off
global listOnce:=0
global stringCheese
global stringCheeseFinal
global Array
global ArrayCount
global animNumber
global whichAnim
global finalAnim
global randAnim
global previousAnim

SortStrCmpLogical(vTextA, vTextB, vOffset)
{
	local
	vRet := DllCall("shlwapi\StrCmpLogicalW", "Wstr",vTextA, "WStr",vTextB)
	return vRet ? vRet : vOffset
}

doOnce()
{
	if (listOnce == 0)
	{
		FileList =
		RegRead, OutputVar, HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Bethesda Softworks\Skyrim, Installed Path
		Loop, %OutputVar%Data\Meshes\actors\character\animations\SkyrimsexcomAnimations\sscdance_a1_s*.hkx*
			FileList = %FileList%%A_LoopFileName%`n
		Sort, FileList, F SortStrCmpLogical
		
		Array := []
		Loop, parse, FileList, `n
		{
			if A_LoopField =
				continue
			stringCheese := A_LoopField
			stringCheese := SubStr(stringCheese, 14, -4)
			if stringCheese is not integer
				continue
			else
				if stringCheese != 1
					stringCheeseFinal := SubStr(A_LoopField, 1, -4)
				else
					stringCheeseFinal := "sscdance_a1_s1_REENTER"
			Array.Push(stringCheeseFinal)
			ArrayCount += 1
		}
		listOnce:=1
	}
}

;SELECT PLAYER -- SHIFT UP
+Up::
{
	BlockInput, On ; ATTENTION Skyrimsex.com/hotdoginbun.com customers - Run this AHK script as admin for BlockInput to work
	Send,{``}{Sleep 15}prid player{Sleep 5}{Enter}{Sleep 15}{``}
	SoundBeep, 750, 150
	BlockInput, Off
	Return
}

;PREVIOUS SSC ANIMATION -- SHIFT LEFT
+Left::
{
	doOnce()
	if !animNumber
	{
		animNumber := ArrayCount
	}
	else
	{
		if (animNumber > 1)
		{
			animNumber -= 1
		}
		else if (animNumber == 1)
		{
			animNumber := ArrayCount
		}
	}
	whichAnim := Array[animNumber]
	previousAnim := whichAnim
	BlockInput, On ; ATTENTION Skyrimsex.com/hotdoginbun.com customers - Run this AHK script as admin for BlockInput to work
	Send,{``}{Sleep 15}sae %whichAnim%{Sleep 5}{Enter}{Sleep 15}{``}
	BlockInput, Off
	Return
}

;SHUFFLE SSC ANIMATION -- SHIFT DOWN
+Down::
{
	doOnce()
	if (!previousAnim)
	{
		finalAnim :=
		GoSub, randAnim
		animNumber := tmp
	}
	else
	{
		finalAnim :=
		GoSub, randAnim
		while (previousAnim == finalAnim)
		{
			finalAnim :=
			GoSub, randAnim
		}
		animNumber := tmp
	}
	previousAnim := finalAnim
	BlockInput, On ; ATTENTION Skyrimsex.com/hotdoginbun.com customers - Run this AHK script as admin for BlockInput to work
	Send,{``}{Sleep 15}sae %finalAnim%{Sleep 5}{Enter}{Sleep 15}{``}
	BlockInput, Off
	randAnim:
		Random, tmp, 1, % Array.Length()
		finalAnim := finalAnim Array[tmp]
	Return
}

;NEXT SSC ANIMATION -- SHIFT RIGHT
+Right::
{
	doOnce()
	if !animNumber
	{
		animNumber := 1
	}
	else
	{
		if (animNumber < ArrayCount)
		{
			animNumber += 1
		}
		else if (animNumber >= ArrayCount)
		{
			animNumber := 1
		}
	}
	whichAnim := Array[animNumber]
	previousAnim := whichAnim
	BlockInput, On ; ATTENTION Skyrimsex.com/hotdoginbun.com customers - Run this AHK script as admin for BlockInput to work
	Send,{``}{Sleep 15}sae %whichAnim%{Sleep 5}{Enter}{Sleep 15}{``}
	BlockInput, Off
	Return
}